//DeskWnd.c

#if (_MSC_VER < 1300)
//VC 6
#pragma comment(linker,"/DEF:DeskWnd.def")

#define NODEFAULTLIB
#pragma comment(linker,"/entry:DllMain")

#endif

#include "../win_ver.h"

#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(push, 3)
#endif
#include <windows.h>
#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(pop)
#endif

#include "../rtlmem.h"
#include "../astonsdk.h"
#include "../st_api.h"
//#include "../drawpng.h"

HMODULE hInstance;

BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}

#define szClassName "DeskWnd"

TAstonData AData;
HWND ChildWindow = NULL;
RECT ClientRC;

LONG WINAPI WindowProc(HWND Window, UINT Message, WPARAM WParam, LPARAM LParam)
{
  switch (Message)
  {
    case WM_PAINT:
    {
      HDC DC;
      PAINTSTRUCT ps;
      RECT r;
      RECT r2;
      UINT uFlags;

      DC = BeginPaint(Window, &ps);
      GetClientRect(Window, &ClientRC);
      GetWindowRect(Window, &r);
      SetRect(&r2, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
      uFlags = DPEx_CORRECTBRUSH;
      if (AData.WallPaperInfo.TileWallpaper != 0)
        uFlags = uFlags | DPEx_TILED;
      if (AData.WallPaperInfo.WallpaperStyle == 0)
        uFlags = uFlags | DPEx_CENTERED;
      DrawSkin(DC, DC, &ClientRC, &r, &r2, AData.WallPaperInfo.WallPaper, AData.WallPaperInfo.DesktopBrush, uFlags);
      DrawEdge(DC, &ClientRC, BDR_SUNKENOUTER, BF_RECT);
      EndPaint(Window, &ps);
      return FALSE;
    }
    break;
    case WM_ERASEBKGND:
    {
      return TRUE;
    }
    break;
    case WM_ENTERSIZEMOVE:
    {
      SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) & ~WS_EX_TRANSPARENT);
    }
    break;
    case WM_MOVING:
    {
      InvalidateRect(Window, NULL, FALSE);
    }
    break;
    case WM_EXITSIZEMOVE:
    {
      SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) | WS_EX_TRANSPARENT);
      InvalidateRect(Window, NULL, FALSE);
    }
    break;
    case WM_NCHITTEST:
    {
      return DefWindowProc(Window, Message, WParam, LParam), HTCAPTION;
    }
  }
  return DefWindowProc(Window, Message, WParam, LParam);
}

void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  WNDCLASS WindowClass;

  if (AstonData->cbsize < sizeof(TAstonData))
    return;
  RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));

  RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
  WindowClass.style = CS_HREDRAW | CS_VREDRAW;
  WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
  WindowClass.hInstance = hInstance;
  WindowClass.lpfnWndProc = WindowProc;
  WindowClass.lpszClassName = szClassName;
  if (!RegisterClass(&WindowClass))
    return;

  ChildWindow = CreateWindowEx(WS_EX_TRANSPARENT, szClassName,
    NULL,
    WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
    0,
    0, 64,
    48, AData.Desktop,
    0,
    hInstance,
    NULL);

  AData.Node->Wnd = ChildWindow;
  GetClientRect(ChildWindow, &ClientRC);
}

void WINAPI DoneModule(void)
{
  if (ChildWindow != NULL)
  {
    DestroyWindow(ChildWindow);
    ChildWindow = NULL;
  }
  UnregisterClass(szClassName, hInstance);
}

//.